<template>
  <div >
    <v-layout justify-center>
      <v-flex xs4 class="ma-2" >
        <div>
          <v-img
          :src="picture"
          class="rounded-card"
          ></v-img>
        </div>
      </v-flex>
    </v-layout>
    <v-card class="pa-3" flat>
      <v-form
        ref="form"
        v-model="valid"
        lazy-validation
      >
          <v-flex v-if="!checkuser">
            <v-flex>
              <v-text-field
              v-model="username"
              :rules="nameRules"
              label="ชื่อ-นามสกุล"
              required
              outlined
              color="secondary"
              ></v-text-field>
            </v-flex>
            <v-flex>
              <v-text-field
              v-model="phone"
              :rules="phoneRules"
              label="เบอร์โทรติดต่อกลับ"
              maxLength="10"
              required
              outlined
              color="secondary"
              ></v-text-field>
            </v-flex>
            <v-flex class="ma-0">
              <v-text-field
              v-model="email"
              label="อีเมล์"
              :rules="emailRules"
              required
              outlined
              color="secondary"
              ></v-text-field>
            </v-flex>
            <v-checkbox class="ma-0" fot="checkboxx" v-model="checkbox" :rules="checkboxrule"><span slot="label" id="checkboxx" style="font-size:10pt">ข้าพเจ้าขอยอมรับ <router-link  to="/rule">กติกา ข้อกำหนด และเงื่อนไข </router-link></span></v-checkbox>
            <v-layout justify-center>
              <v-btn color="accent primary--text" rounded @click="saveFrom" :disabled="!valid">
                ลงทะเบียนสมาชิก
              </v-btn>
            </v-layout>
          </v-flex>

        <v-flex v-else>
          <v-flex>
            <v-text-field
            v-model="usernameF"
            label="ชื่อ-นามสกุล"
            outlined
            color="secondary"
            readonly
            ></v-text-field>
          </v-flex>
          <v-flex>
            <v-text-field
            v-model="phoneF"
            label="เบอร์โทรติดต่อกลับ"
            outlined
            color="secondary"
            readonly
            ></v-text-field>
          </v-flex>
          <v-flex class="ma-0">
            <v-text-field
            v-model="emailF"
            outlined
            color="secondary"
            readonly
            ></v-text-field>
          </v-flex>
        </v-flex>
      </v-form>
    </v-card>
  </div>
</template>

<script>
export default {
  data: () => ({
    usernameF: '',
    phoneF: '',
    emailF: '',
    dataExist: '',
    valid: true,
    code: null,
    nameRules: [
      v => !!v || 'ขออภัย ท่าน กรอกข้อมูลไม่ถูกต้องครบถ้วน กรุณากรอกข้อมูลใหม่อีกครั้งค่ะ'
    ],
    phoneRules: [
      v => !!v || 'ขออภัย ท่าน กรอกข้อมูลไม่ถูกต้องครบถ้วน กรุณากรอกข้อมูลใหม่อีกครั้งค่ะ',
      v => /^(08|06|09)[0-9]{8}$/.test(v) || 'ขออภัย ท่าน กรอกข้อมูลไม่ถูกต้องครบถ้วน กรุณากรอกข้อมูลใหม่อีกครั้งค่ะ'
    ],
    emailRules: [
      v => /(^$)|(.+@.+\..+)/.test(v) || 'ขออภัย ท่าน กรอกข้อมูลไม่ถูกต้องครบถ้วน กรุณากรอกข้อมูลใหม่อีกครั้งค่ะ'
    ],
    checkbox: false,
    checkboxrule: [v => !!v || '']
  }),
  created () {
    console.log('created')
    this.$store.dispatch('app/runLoader', true)
    this.$store.dispatch('user/checkUserData').then((result) => {
      console.log(result.id)
      if (result.id === 'undefined') {
        this.linelogin()
      }
      if (result.exists) {
        this.dataExist = result.exists
        this.$store.dispatch('app/runLoader', false)
        this.usernameF = result.data().fullName
        this.phoneF = result.data().mobileNo
        this.emailF = result.data().email
        console.log('Have User Data')
      } else {
        this.linelogin()
      }
      console.log(result)
    }).catch(error => { console.log(error) })
  },
  methods: {
    validate () {
      if (this.$refs.form.validate()) {
        this.snackbar = true
      }
    },
    linelogin () {
      // this.$store.dispatch('app/runLoader', true)
      this.$store.dispatch('user/CallLineAPI')
      this.$store.dispatch('app/runLoader', false)
      // .then((checkAuth) => {
      //   if (checkAuth) {
      //     console.log('in')
      //     this.$store.dispatch('app/runLoader', false)
      //     this.$router.push('/upload')
      //   }
      //     console.log('out :',checkAuth)

      //   this.$store.dispatch('app/runLoader', false)
      // })
      // .catch(error => {
      //   console.log(error)
      //   this.$store.dispatch('app/runLoader', false)
      // })
    },
    saveFrom () {
      this.$refs.form.validate()
      if (this.$refs.form.validate()) {
        this.$store.dispatch('user/saveUserRegister', { phone: this.phone, email: this.email })
      }
    }
  },
  computed: {
    username: {
      set (value) {
        this.$store.dispatch('user/addUsername', { name: value })
      },
      get () {
        return this.$store.getters['user/getLineInfo'].name
      }
    },
    picture: {
      set (value) {
        this.$store.dispatch('user/addPicture', { picture: value })
      },
      get () {
        return this.$store.getters['user/getLineInfo'].picture
      }
    },
    phone: {
      set (value) {
        this.$store.dispatch('user/addPhone', value)
      },
      get () {
        return this.$store.getters['user/getPhone']
      }
    },
    email: {
      set (value) {
        this.$store.dispatch('user/addEmail', value)
      },
      get () {
        return this.$store.getters['user/getEmail']
      }
    },
    checkuser () {
      return this.$store.getters['user/getIsUserFB']
    }
  }
}
</script>
<style>
.rounded-card{
    border-radius:100px;
}
</style>
